> [Yeoman](http://yeoman.io) generator that scaffolds out the module structure

## Features

Automatically fetch latest version in modules repository and tests


## Getting Started

- Make sure you have svn installed

  Linux

```shell
  sudo apt-get install subversion
```

  Macos

```
  brew install subversion
```


- Be sure to be in your modules repository


# NPM frontend boilerplate


## Global name

If you implement a plugin for Marionette, you will only need the Marionette plugin name and no `module.exports` will be needed.

If you implement a simple function, you will only need the standalone name.

### Marionette plugin name

Defined in src/view.coffee

```coffee
  Marionette.G4.BoilerPlate
```

### Standalone name

Defined in grunt/browserify.coffee

```coffee
  G4.boilerPlate
```

## NPM scripts

To build & run all tests (unit and functional)
```sh
$ npm run travis
```

To open istanbul report in your default browser
```sh
$ npm run report
```

To open SpecRunner in your default browser
```sh
$ npm run spec
```

To open functional test in your default browser
```sh
$ npm run example
```

To publish your module with safety
```sh
$ npm run update_package
```

## How to install web driver

1. Download last version of the driver from google page [Chromedriver]
2. Unzip it in the folder of your choice
3. Add chromedriver path to environment variable path
   e.g.: '/Users/user/Documents/drivers/'

### Example for MAC
1. Go to your home

  ```sh
  $ cd
  ```

2. Edit .bash_profile

  ```sh
  $ nano .bash_profile
  ```

3. Add those lines

  ```
  export chromeBinaryPath='/Users/user/Documents/drivers/'
  export PATH="$chromeBinaryPath:$PATH"
  ```

4. Restart your terminal and check it

  ```
  $ echo $PATH
  ```


[//]: #

  [Chromedriver]: <https://sites.google.com/a/chromium.org/chromedriver/>

# npm-backend-module-boilerplate
A raw base for writing back-end modules @Intelisis G4.


## Install
```sh
> npm install %module_name% --save
```

## Usage
```coffee
Klass = require '%module_name%'

klassInstance = new Klass
```

## API

#### %module_name% Parent 1
##### klassInstance.fn1(opt1, opt2)
Description of fn1

##### klassInstance.fn2(opt1)
Description of fn2

## How to develop
```sh
> npm install
> grunt
```
